/**
 * @module @zk-kit/imt
 * @version 2.0.0-beta.4
 * @file Incremental Merkle tree implementations in TypeScript.
 * @copyright Ethereum Foundation 2024
 * @license MIT
 * @see [Github]{@link https://github.com/privacy-scaling-explorations/zk-kit/tree/main/packages/imt}
*/
var zkKitImt=function(t){"use strict";function e(t,e,...s){if(void 0===t)throw new TypeError(`Parameter '${e}' is not defined`);if(!s.includes(typeof t))throw new TypeError(`Parameter '${e}' is none of these types: ${s.join(", ")}`)}class s{constructor(t,s,i,r=2,o=[]){var n;if(e(t,"hash","function"),e(s,"depth","number"),e(i,"zeroValue","number","string","bigint"),e(r,"arity","number"),e(o,"leaves","object"),o.length>Math.pow(r,s))throw new Error(`The tree cannot contain more than ${Math.pow(r,s)} leaves`);this._hash=t,this._depth=s,this._zeroes=[],this._nodes=[],this._arity=r;for(let e=0;e<s;e+=1)this._zeroes.push(i),this._nodes[e]=[],i=t(Array(this._arity).fill(i));if(this._nodes[s]=[],o.length>0){this._nodes[0]=o;for(let e=0;e<s;e+=1)for(let s=0;s<Math.ceil(this._nodes[e].length/r);s+=1){const i=s*r,o=[];for(let t=0;t<r;t+=1)o.push(null!==(n=this._nodes[e][i+t])&&void 0!==n?n:this.zeroes[e]);this._nodes[e+1][s]=t(o)}}else this._nodes[s][0]=i;Object.freeze(this._zeroes),Object.freeze(this._nodes)}get root(){return this._nodes[this.depth][0]}get depth(){return this._depth}get leaves(){return this._nodes[0].slice()}get zeroes(){return this._zeroes}get arity(){return this._arity}indexOf(t){return e(t,"leaf","number","string","bigint"),this._nodes[0].indexOf(t)}insert(t){if(e(t,"leaf","number","string","bigint"),this._nodes[0].length>=Math.pow(this.arity,this.depth))throw new Error("The tree is full");let s=t,i=this._nodes[0].length;for(let t=0;t<this.depth;t+=1){const e=i-i%this.arity,r=e+this.arity,o=[];this._nodes[t][i]=s;for(let s=e;s<r;s+=1)s<this._nodes[t].length?o.push(this._nodes[t][s]):o.push(this._zeroes[t]);s=this._hash(o),i=Math.floor(i/this.arity)}this._nodes[this.depth][0]=s}delete(t){this.update(t,this.zeroes[0])}update(t,s){if(e(t,"index","number"),t<0||t>=this._nodes[0].length)throw new Error("The leaf does not exist in this tree");let i=s;for(let e=0;e<this.depth;e+=1){const s=t-t%this.arity,r=s+this.arity,o=[];this._nodes[e][t]=i;for(let t=s;t<r;t+=1)t<this._nodes[e].length?o.push(this._nodes[e][t]):o.push(this.zeroes[e]);i=this._hash(o),t=Math.floor(t/this.arity)}this._nodes[this.depth][0]=i}createProof(t){if(e(t,"index","number"),t<0||t>=this._nodes[0].length)throw new Error("The leaf does not exist in this tree");const s=[],i=[],r=t;for(let e=0;e<this.depth;e+=1){const r=t%this.arity,o=t-r,n=o+this.arity;i[e]=r,s[e]=[];for(let i=o;i<n;i+=1)i!==t&&(i<this._nodes[e].length?s[e].push(this._nodes[e][i]):s[e].push(this.zeroes[e]));t=Math.floor(t/this.arity)}return{root:this.root,leaf:this._nodes[0][r],pathIndices:i,siblings:s,leafIndex:r}}verifyProof(t){return s.verifyProof(t,this._hash)}static verifyProof(t,s){e(t,"proof","object"),e(t.root,"proof.root","number","string","bigint"),e(t.leaf,"proof.leaf","number","string","bigint"),e(t.siblings,"proof.siblings","object"),e(t.pathIndices,"proof.pathElements","object");let i=t.leaf;for(let e=0;e<t.siblings.length;e+=1){const r=t.siblings[e].slice();r.splice(t.pathIndices[e],0,i),i=s(r)}return t.root===i}}function i(t,e){if(void 0===t)throw new TypeError(`Parameter '${e}' is not defined`)}function r(t,e){if("number"!=typeof t)throw new TypeError(`Parameter '${e}' is not a number`)}function o(t,e){if("object"!=typeof t&&!Array.isArray(t))throw new TypeError(`Parameter '${e}' is not an array`)}class n{constructor(t,e=[]){i(t,"hash"),function(t,e){if("function"!=typeof t)throw new TypeError(`Parameter '${e}' is not a function`)}(t,"hash"),o(e,"leaves"),this._nodes=[[]],this._hash=t,e.length>0&&this.insertMany(e)}get root(){return this._nodes[this.depth][0]}get depth(){return this._nodes.length-1}get leaves(){return this._nodes[0].slice()}get size(){return this._nodes[0].length}indexOf(t){return i(t,"leaf"),this._nodes[0].indexOf(t)}has(t){return i(t,"leaf"),this._nodes[0].includes(t)}insert(t){i(t,"leaf"),this.depth<Math.ceil(Math.log2(this.size+1))&&this._nodes.push([]);let e=t,s=this.size;for(let t=0;t<this.depth;t+=1){if(this._nodes[t][s]=e,1&s){const i=this._nodes[t][s-1];e=this._hash(i,e)}s>>=1}this._nodes[this.depth]=[e]}insertMany(t){if(i(t,"leaves"),o(t,"leaves"),0===t.length)throw new Error("There are no leaves to add");let e=this.size>>1;this._nodes[0].push(...t);const s=Math.ceil(Math.log2(this.size))-this.depth;for(let t=0;t<s;t+=1)this._nodes.push([]);for(let t=0;t<this.depth;t+=1){const s=Math.ceil(this._nodes[t].length/2);for(let i=e;i<s;i+=1){const e=this._nodes[t][2*i+1],s=this._nodes[t][2*i],r=e?this._hash(s,e):s;this._nodes[t+1][i]=r}e>>=1}}update(t,e){i(t,"index"),i(e,"newLeaf"),r(t,"index");let s=e;for(let e=0;e<this.depth;e+=1){if(this._nodes[e][t]=s,1&t){const i=this._nodes[e][t-1];s=this._hash(i,s)}else{const i=this._nodes[e][t+1];i&&(s=this._hash(s,i))}t>>=1}this._nodes[this.depth]=[s]}generateProof(t){if(i(t,"index"),r(t,"index"),t<0||t>=this.size)throw new Error(`The leaf at index '${t}' does not exist in this tree`);const e=this.leaves[t],s=[],o=[];for(let e=0;e<this.depth;e+=1){const i=1&t,r=i?t-1:t+1,n=this._nodes[e][r];void 0!==n&&(o.push(i),s.push(n)),t>>=1}return{root:this.root,leaf:e,index:Number.parseInt(o.reverse().join(""),2),siblings:s}}verifyProof(t){return n.verifyProof(t,this._hash)}static verifyProof(t,e){i(t,"proof");const{root:s,leaf:n,siblings:h,index:a}=t;i(t.root,"proof.root"),i(t.leaf,"proof.leaf"),i(t.siblings,"proof.siblings"),i(t.index,"proof.index"),o(t.siblings,"proof.siblings"),r(t.index,"proof.index");let d=n;for(let t=0;t<h.length;t+=1)d=a>>t&1?e(h[t],d):e(d,h[t]);return s===d}export(){return JSON.stringify(this._nodes,((t,e)=>"bigint"==typeof e?e.toString():e))}import(t){if(i(t,"nodes"),function(t,e){if("string"!=typeof t)throw new TypeError(`Parameter '${e}' is not a string`)}(t,"nodes"),0!==this.size)throw new Error("Import failed: the target tree structure is not empty");this._nodes=JSON.parse(t)}}return t.IMT=s,t.LeanIMT=n,t}({});
